<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Teacher_Discipline extends Controller_UserEnvi {
    
	private function GetGrades($db) {
	
		$GradeList = $db->GetGrades();
		$Grade = array(); $i = 0;
		
		foreach ($GradeList as $row){
			$i++;
			$Grade[$i]['GradeID'] = $row['GradeID'];
			$Grade[$i]['Grade'] = $row['Grade'];
			$Grade[$i]['Degree'] = $row['Degree'];
			if ($row['Degree'] == 'bachelor' || $row['Degree'] == 'specialist')
				$Grade[$i]['Title'] = 'Курс '.$row['Grade'];
			if ($row['Degree'] == 'master')
				$Grade[$i]['Title'] = 'Магистратура '.$row['Grade'];
		}
	
		return $Grade;
	}
	
    public function action_CreateDiscipline()
    {
        $twig = Twig::factory('teacher/discipline/CreateDiscipline');
        $db = new Model_Teacher_Map;
        $twig->User = $this->UserInfo;
		$twig->FacultiesList = $this->GetFaculties($db);
        $twig->SubjectsList = $this->GetSubjectsList($db,  $this->UserInfo['FacultyID']);
        $twig->GradesList = $this->GetGrades($db);	
        $this->response->body($twig);
		
    }
	
	public function action_EditSettings()
    {
        $id = $this->request->param('id');
        $db = new Model_Teacher_Map;
        $twig = Twig::factory('teacher/discipline/EditSettings');
		
		$twig->User = $this->UserInfo;
		
		$twig->FacultiesList = $this->GetFaculties($db);
        $twig->Discipline = $this->getDisciplineInfo($db, $id);
        $twig->SubjectsList = $this->GetSubjectsList($db,  $twig->Discipline['FacultyID']);
        $twig->GradesList = $this->GetGrades($db);
		
		$this->response->body($twig);
	}

	public function action_EditStructure()
    {
        $id = $this->request->param('id');
        $db = new Model_Teacher_Map;
        $twig = Twig::factory('teacher/discipline/EditStructure');
		
        $twig->User = $this->UserInfo; 
		$twig->Discipline = $this->getDisciplineInfo($db, $id);
        $twig->Map = $this->GetMapInfo($db->getMapForDiscipline($this->UserInfo['TeacherID'], $id));
		
		$this->response->body($twig);
	}
	
	public function action_EditGroups()
    {
        $id = $this->request->param('id');
        $db = new Model_Teacher_Map;
        $twig = Twig::factory('teacher/discipline/EditGroups');
		
		$twig->User = $this->UserInfo;
		$twig->Discipline = $this->getDisciplineInfo($db, $id);
		$twig->GroupsForDiscipline = $this->GetGroupsForDiscipline($db, $id);
		$twig->StudyGroups = $this->GetStudyGroupsOrdByGroups($db, $twig->Discipline['GradeID'], $twig->Discipline['FacultyID']);
		
		$this->response->body($twig);
	}
	
    public function action_EditStudents()
    {
        $id = $this->request->param('id');
        $db = new Model_Teacher_Map;
        $twig = Twig::factory('teacher/discipline/EditStudents');
		
		$twig->User = $this->UserInfo;
		$twig->Discipline = $this->getDisciplineInfo($db, $id);
		$twig->Students = $this->GetStudentsList($db, $id);
		$twig->GradesList = $this->GetGrades($db);
		$twig->StudyGroups = $this->GetStudyGroupsOrdByGroups($db, $twig->Discipline['GradeID'], $twig->Discipline['FacultyID']);
		
		$this->response->body($twig);
	}
	
    public function action_EditTeachers()
    {
        $id = $this->request->param('id');
        $db = new Model_Teacher_Map;
        $twig = Twig::factory('teacher/discipline/EditTeachers');
		
		$twig->User = $this->UserInfo;
		$twig->Discipline = $this->getDisciplineInfo($db, $id);
		$twig->BindTeachersList = $this->GetTeachersForDiscipline($db, $id);
		$twig->FacultiesList = $this->GetFaculties($db);
		$twig->Departments = $this->GetDepartments($db, $twig->Discipline['FacultyID']);	
		//$twig->TeachersList = $this->GetTeachersByDepartment($db, $twig->Discipline['DepID']);
		
		$this->response->body($twig);
	}
	
    private function GetMapInfo($map) {
        $mapHandled = array();
        
        $maxRate = 0; $i = 0; $module = 0;
        foreach($map as $row)
        {
			if($row['ModuleID'] != $module)
			{
				$i++;
				$module = $row['ModuleID'];
				$mapHandled[$i]['ModuleID'] = $row['ModuleID'];
				$mapHandled[$i]['CurrentControl'] = 0;
				$mapHandled[$i]['LandmarkControl'] = 0;
			}
			if(!isset($mapHandled[$i]['SubmodulesCount']))
			{
				$mapHandled[$i]['SubmodulesCount'] = 0;
				$mapHandled[$i]['MaxRate'] = 0;
			}
			$mapHandled[$i]['isExam'] = $row['isExam'];
			$j = $mapHandled[$i]['SubmodulesCount'] += 1;
			$mapHandled[$i]['MaxRate'] += (int) $row['MaxRate'];
			$mapHandled[$i]['ModuleTitle'] = $row['ModuleName'];
			$mapHandled[$i][$j]['SubmoduleID'] = $row['SubmoduleID'];
			$mapHandled[$i][$j]['Title'] = $row['SubModuleName'];
			$mapHandled[$i][$j]['Description'] = $row['SubmoduleDescription'];
			$mapHandled[$i][$j]['SubmoduleControl'] = $row['SubmoduleControl'];
			$mapHandled[$i][$j]['MaxRate'] = (int) $row['MaxRate'];
			$maxRate += $row['MaxRate'];
			if ($row['SubmoduleControl'] == 'CurrentControl')
				 $mapHandled[$i]['CurrentControl'] += (int) $row['MaxRate'];
			if ($row['SubmoduleControl'] == 'LandmarkControl')
				 $mapHandled[$i]['LandmarkControl'] += (int) $row['MaxRate'];
        }
		$mapHandled['ModulesCount'] = $i;
		$mapHandled['MaxRate'] = (int) $maxRate; 

        return $mapHandled;
    }
    
    public function getDisciplineInfo($db, $id)
    {
        $info = $db->getDisciplineInfoByID($id);

        if($info->count() == 0)
           throw HTTP_Exception::factory(404, "Учебная карта дисциплины с ID $id не найдена!");
		else
			$info = $info->offsetGet(0);
		
		$subject['AuthorID'] = $info['AuthorID'];
        if($this->UserInfo['TeacherID'] != $subject['AuthorID'])
           throw HTTP_Exception::factory(403, "Недостаточно прав для редактирования.");
		
		$subject['DisciplineID'] = $id;
		$subject['DepID'] = $info['DepID'];
		$subject['FacultyID'] = $info['FacultyID'];
		$subject['isLocked'] = $info['isLocked'];
		
		$subject['SemesterID'] = $info['SemesterID'];
        $semester = $db->getSemesterInfo($subject['SemesterID']);
        $subject['SemesterNum'] = $semester['SemesterNum'] == 1 ? 'Осенний' : 'Весенний';
        $subject['SemesterYear'] = $semester['SemesterYear'];
		
		$teachers = $db->getTeachersForDiscipline($id);
		
        $subject['SubjectName'] = $info['SubjectName'];
		$subject['SubjectID'] = $info['SubjectID'];
		$subject['ExamType'] = $info['ExamType'];
        
        $subject['LectureHours'] = $info['LectionCount'];
        $subject['PracticeHours'] = $info['PracticeCount'];
		$subject['GradeID'] = $info['DisciplineGrade'];
		
        $teachersHandled = array(); $i = 0;
        
        foreach ($teachers as $row) {
            $teachersHandled[$i] = $row['TeacherLast'].' '.$row['TeacherFirst'].'';
            if(!empty($row['TeacherSecond']))
            {
                $teachersHandled[$i] .= ' '.$row['TeacherSecond'];
            }
            $i++;
        }
        $subject['Teachers'] = implode(', ', $teachersHandled);
		
		return $subject;
    }
	
    private function GetSubjectsList($db,$FacultyID)
    {
		$NameFilter = '';
        $list = $db->GetSubjectList($NameFilter,$FacultyID);
		
		$SubjectsList = array(); $i = 0;
		
		foreach ($list as $row) {
			$i++;
			$SubjectsList[$i]['ID'] = $row['SubjectID'];
			$SubjectsList[$i]['Title'] = $row['SubjectName'];
			$SubjectsList[$i]['Abbr'] = $row['SubjectAbbr'];
		}
		
		return $SubjectsList;
	}
	
	private function GetFaculties($db) {
		$list = $db->GetFaculties();
		
		$FacList = array(); $i = 0;
		
		foreach ($list as $row) {
			$i++;
			$FacList[$i]['FacultyID'] = $row['FacultyID'];
			$FacList[$i]['FacultyName'] = $row['FacultyName'];
			$FacList[$i]['FacultyAbbr'] = $row['FacultyAbbr'];
		}
		
		return $FacList;
	}
	
	private function GetDepartments($db, $FacultyID) {
		$list = $db->GetDepartments($FacultyID);
		
		$DepList = array(); $i = 0;
		
		foreach ($list as $row) {
			$i++;
			$DepList[$i]['DepID'] = $row['DepID'];
			$DepList[$i]['DepName'] = $row['DepName'];
		}
		
		return $DepList;
	}
	
	private function GetStudentsList($db, $DisciplineID)
	{
        $students = $db->GetStudentsForDiscipline($this->UserInfo['TeacherID'], $DisciplineID);
        $studentsHandled = array();
        $i = 0;
		
        foreach($students as $row) {
			$i++;
			$studentsHandled[$i]['StudentID'] = $row['StudentID'];
			$studentsHandled[$i]['LastName'] = $row['LastName'];
			$studentsHandled[$i]['FirstName'] = $row['FirstName'];
			$studentsHandled[$i]['SecondName'] = $row['SecondName'];
			$studentsHandled[$i]['Grade'] = $row['Grade'];
			$studentsHandled[$i]['GroupNum'] = $row['GroupNum'];
			$studentsHandled[$i]['Type'] = $row['Type'];
			$studentsHandled[$i]['GroupID'] = $row['GroupID'];
        }
        return $studentsHandled;
	}
	
	private function GetStudyGroupsOrdByGroups($db, $Grade, $FacultyID) {
		$Groups = $db->GetStudyGroupsOrdByGroups($Grade, $FacultyID);
		$GroupsHandled = array();
		$i = 0;
		
		foreach($Groups as $row) {
			$i++;
			$GroupsHandled[$i]['GroupID'] = $row['GroupID'];
			$GroupsHandled[$i]['GroupNum'] = $row['GroupNum'];
			$GroupsHandled[$i]['SpecID'] = $row['SpecID'];
			$GroupsHandled[$i]['SpecName'] = $row['SpecName'];
			$GroupsHandled[$i]['SpecAbbr'] = $row['SpecAbbr'];
		}
		
		return $GroupsHandled;
	}
	
	private function GetGroupsForDiscipline($db, $DisciplineID) {
		$Groups = $db->GetGroupsForDiscipline($DisciplineID);
		
		$GroupsHandled = array();
		$i = 0;
		
		foreach($Groups as $row) {
			$i++;
			$GroupsHandled[$i]['GroupID'] = $row['GroupID'];
			$GroupsHandled[$i]['DiscGroupID'] = $row['DiscGroupID'];
			$GroupsHandled[$i]['GroupGrade'] = $row['GroupGrade'];
			$GroupsHandled[$i]['GroupNum'] = $row['GroupNum'];
			$GroupsHandled[$i]['SpecName'] = $row['SpecName'];
			$GroupsHandled[$i]['SpecAbbr'] = $row['SpecAbbr'];
		}
		
		return $GroupsHandled;
	}
	
	private function GetTeachersByDepartment($db, $DepartmentID){
		$Teachers = $db->GetTeachersByDepartment($DepartmentID);
		
		$TeachersHandled = array();
		$i = 0;
		
		foreach($Teachers as $row) {
			$i++;
			$TeachersHandled[$i]['TeacherID'] = $row['TeacherID'];
			$TeachersHandled[$i]['TeacherLast'] = $row['TeacherLast'];
			$TeachersHandled[$i]['TeacherFirst'] = $row['TeacherFirst'];
			$TeachersHandled[$i]['TeacherSecond'] = $row['TeacherSecond'];
			$TeachersHandled[$i]['JobPositionName'] = $row['JobPositionName'];
		}
		
		return $TeachersHandled;
	}
	
	private function GetTeachersForDiscipline($db, $DisciplineID) {
		$Teachers = $db->GetTeachersForDiscipline($DisciplineID);
		
		$TeachersHandled = array();
		$i = 0;
		
		foreach($Teachers as $row) {
			$i++;
			$TeachersHandled[$i]['TeacherID'] = $row['TeacherID'];
			$TeachersHandled[$i]['TeacherLast'] = $row['TeacherLast'];
			$TeachersHandled[$i]['TeacherFirst'] = $row['TeacherFirst'];
			$TeachersHandled[$i]['TeacherSecond'] = $row['TeacherSecond'];
			$TeachersHandled[$i]['JobPositionID'] = $row['JobPositionID'];
			$TeachersHandled[$i]['JobPositionName'] = $row['JobPositionName'];
			$TeachersHandled[$i]['DepartmentID'] = $row['DepartmentID'];
			$TeachersHandled[$i]['DepartmentName'] = $row['DepartmentName'];
			$TeachersHandled[$i]['FacultyID'] = $row['FacultyID'];
			$TeachersHandled[$i]['FacultyName'] = $row['FacultyName'];
			$TeachersHandled[$i]['FacultyAbbreviation'] = $row['FacultyAbbreviation'];
			$TeachersHandled[$i]['isAuthor'] = $row['isAuthor'];
		}

		
		return $TeachersHandled;
	}
}
            